> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/vm/disk/detachdisks.md).

# DetachDisks

## 1. API Description

This API (DetachDisks) is used to detach one or more disks from an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Disks to be detached should be attached to the same instance.</mark> <mark style="color:blue;">If any of the disks is undetachable, the operation will not be performed.</mark>
* <mark style="color:blue;">Only operations on disks with the status of</mark> <mark style="color:blue;">`IN_USE`</mark> <mark style="color:blue;">are supported.</mark>
* <mark style="color:blue;">Only operations on disks that are detachable (</mark><mark style="color:blue;">`portable`</mark> <mark style="color:blue;">=</mark> <mark style="color:blue;">`true`</mark><mark style="color:blue;">) are supported.</mark>
* <mark style="color:blue;">Only operations on data disks are supported.</mark>
* <mark style="color:blue;">A maximum of 10 disks can be detached from an instance in one request.</mark>
* <mark style="color:blue;">This API is an async API. A request ID is returned after the creation request is sent. However, it does not mean the operation has been completed. You can use</mark> [<mark style="color:purple;">`DescribeDisks`</mark>](/api-reference/compute/vm/disk/describedisks.md) <mark style="color:blue;">to query the status of the disk. If the status changes from</mark> <mark style="color:blue;">`IN_USE`</mark> <mark style="color:blue;">to</mark> <mark style="color:blue;">`AVAILABLE`</mark><mark style="color:blue;">, it means that the disk is detached successfully.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                      |
| -------------- | -------- | --------------- | -------------------------------- |
| diskIds        | Yes      | Array of String | ID list of disks to be detached. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Detach one or more disks from an instance.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DetachDisks
<Common Request Params>

Request:
{
  "diskIds": [
    "your-disk-id"
  ]
}

Response:
{
  "requestId": "T86A56634-582A-4615-BBE2-ABFE192EE7CE",
  "response": {
    "requestId": "T86A56634-582A-4615-BBE2-ABFE192EE7CE"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
